.class Lcom/android/server/BatteryService;
.super Landroid/os/Binder;
.source "BatteryService.java"


# static fields
.field private static final BATTERY_PLUGGED_NONE:I = 0x0

.field static final BATTERY_SCALE:I = 0x64

.field private static final BATTERY_STATS_SERVICE_NAME:Ljava/lang/String; = "batteryinfo"

.field private static final CRITICAL_BATTERY_LEVEL:I = 0x4

.field private static final DUMPSYS_ARGS:[Ljava/lang/String; = null

.field private static final DUMPSYS_DATA_PATH:Ljava/lang/String; = "/data/system/"

.field private static final DUMP_MAX_LENGTH:I = 0x6000

.field private static final LOCAL_LOGV:Z

.field private static final TAG:Ljava/lang/String;


# instance fields
.field private isBroadcsatBatteryIntent:Z

.field private mAcOnline:Z

.field private mBatteryHealth:I

.field private mBatteryLevel:I

.field private mBatteryLevelCritical:Z

.field private mBatteryPresent:Z

.field private final mBatteryStats:Lcom/android/internal/app/IBatteryStats;

.field private mBatteryStatus:I

.field private mBatteryTechnology:Ljava/lang/String;

.field private mBatteryTemperature:I

.field private mBatteryVoltage:I

.field private final mContext:Landroid/content/Context;

.field private mDischargeStartLevel:I

.field private mDischargeStartTime:J

.field private mLastBatteryHealth:I

.field private mLastBatteryLevel:I

.field private mLastBatteryLevelCritical:Z

.field private mLastBatteryPresent:Z

.field private mLastBatteryStatus:I

.field private mLastBatteryTemperature:I

.field private mLastBatteryVoltage:I

.field private mLastPlugType:I

.field private mLastUnsupportedCharger:Z

.field private mLowBatteryCloseWarningLevel:I

.field private mLowBatteryWarningLevel:I

.field private mLowBatteryWarningLevelAry:[I

.field private mPlugType:I

.field private mSentLowBatteryBroadcast:Z

.field private mUEventObserver:Landroid/os/UEventObserver;

.field private mUnsupportedCharger:Z

.field private mUsbOnline:Z


# direct methods
.method static constructor <clinit>()V
    .registers 3

    .prologue
    .line 75
    const-class v0, Lcom/android/server/BatteryService;

    invoke-virtual {v0}, Ljava/lang/Class;->getSimpleName()Ljava/lang/String;

    move-result-object v0

    sput-object v0, Lcom/android/server/BatteryService;->TAG:Ljava/lang/String;

    .line 86
    const/4 v0, 0x2

    new-array v0, v0, [Ljava/lang/String;

    const/4 v1, 0x0

    const-string v2, "--checkin"

    aput-object v2, v0, v1

    const/4 v1, 0x1

    const-string v2, "-u"

    aput-object v2, v0, v1

    sput-object v0, Lcom/android/server/BatteryService;->DUMPSYS_ARGS:[Ljava/lang/String;

    return-void
.end method

.method public constructor <init>(Landroid/content/Context;)V
    .registers 4
    .parameter "context"

    .prologue
    const/4 v1, 0x0

    .line 131
    invoke-direct {p0}, Landroid/os/Binder;-><init>()V

    .line 119
    const/4 v0, 0x0

    iput-object v0, p0, Lcom/android/server/BatteryService;->mLowBatteryWarningLevelAry:[I

    .line 122
    const/4 v0, -0x1

    iput v0, p0, Lcom/android/server/BatteryService;->mLastPlugType:I

    .line 127
    iput-boolean v1, p0, Lcom/android/server/BatteryService;->mSentLowBatteryBroadcast:Z

    .line 129
    iput-boolean v1, p0, Lcom/android/server/BatteryService;->isBroadcsatBatteryIntent:Z

    .line 179
    new-instance v0, Lcom/android/server/BatteryService$1;

    invoke-direct {v0, p0}, Lcom/android/server/BatteryService$1;-><init>(Lcom/android/server/BatteryService;)V

    iput-object v0, p0, Lcom/android/server/BatteryService;->mUEventObserver:Landroid/os/UEventObserver;

    .line 132
    iput-object p1, p0, Lcom/android/server/BatteryService;->mContext:Landroid/content/Context;

    .line 133
    invoke-static {}, Lcom/android/server/am/BatteryStatsService;->getService()Lcom/android/internal/app/IBatteryStats;

    move-result-object v0

    iput-object v0, p0, Lcom/android/server/BatteryService;->mBatteryStats:Lcom/android/internal/app/IBatteryStats;

    .line 135
    iget-object v0, p0, Lcom/android/server/BatteryService;->mContext:Landroid/content/Context;

    invoke-virtual {v0}, Landroid/content/Context;->getResources()Landroid/content/res/Resources;

    move-result-object v0

    const v1, 0x10e000b

    invoke-virtual {v0, v1}, Landroid/content/res/Resources;->getInteger(I)I

    move-result v0

    iput v0, p0, Lcom/android/server/BatteryService;->mLowBatteryWarningLevel:I

    .line 137
    iget-object v0, p0, Lcom/android/server/BatteryService;->mContext:Landroid/content/Context;

    invoke-virtual {v0}, Landroid/content/Context;->getResources()Landroid/content/res/Resources;

    move-result-object v0

    const v1, 0x10e000c

    invoke-virtual {v0, v1}, Landroid/content/res/Resources;->getInteger(I)I

    move-result v0

    iput v0, p0, Lcom/android/server/BatteryService;->mLowBatteryCloseWarningLevel:I

    .line 144
    const/4 v0, 0x3

    new-array v0, v0, [I

    fill-array-data v0, :array_4e

    iput-object v0, p0, Lcom/android/server/BatteryService;->mLowBatteryWarningLevelAry:[I

    .line 145
    iget-object v0, p0, Lcom/android/server/BatteryService;->mUEventObserver:Landroid/os/UEventObserver;

    const-string v1, "SUBSYSTEM=power_supply"

    invoke-virtual {v0, v1}, Landroid/os/UEventObserver;->startObserving(Ljava/lang/String;)V

    .line 148
    invoke-direct {p0}, Lcom/android/server/BatteryService;->update()V

    .line 149
    return-void

    .line 144
    :array_4e
    .array-data 0x4
        0xet 0x0t 0x0t 0x0t
        0x9t 0x0t 0x0t 0x0t
        0x4t 0x0t 0x0t 0x0t
    .end array-data
.end method

.method static synthetic access$000(Lcom/android/server/BatteryService;)V
    .registers 1
    .parameter "x0"

    .prologue
    .line 74
    invoke-direct {p0}, Lcom/android/server/BatteryService;->update()V

    return-void
.end method

.method private final getIcon(I)I
    .registers 4
    .parameter "level"

    .prologue
    .line 602
    iget v0, p0, Lcom/android/server/BatteryService;->mBatteryStatus:I

    const/4 v1, 0x2

    if-ne v0, v1, :cond_9

    .line 603
    const v0, 0x1080299

    .line 612
    :goto_8
    return v0

    .line 604
    :cond_9
    iget v0, p0, Lcom/android/server/BatteryService;->mBatteryStatus:I

    const/4 v1, 0x3

    if-eq v0, v1, :cond_18

    iget v0, p0, Lcom/android/server/BatteryService;->mBatteryStatus:I

    const/4 v1, 0x4

    if-eq v0, v1, :cond_18

    iget v0, p0, Lcom/android/server/BatteryService;->mBatteryStatus:I

    const/4 v1, 0x5

    if-ne v0, v1, :cond_1c

    .line 610
    :cond_18
    const v0, 0x1080291

    goto :goto_8

    .line 612
    :cond_1c
    const v0, 0x10802a0

    goto :goto_8
.end method

.method private final logBatteryStats()V
    .registers 13

    .prologue
    const-string v9, "BATTERY_DISCHARGE_INFO"

    const-string v11, "failed to delete temporary dumpsys file: "

    const-string v10, "failed to close dumpsys output stream"

    .line 536
    const-string v7, "batteryinfo"

    invoke-static {v7}, Landroid/os/ServiceManager;->getService(Ljava/lang/String;)Landroid/os/IBinder;

    move-result-object v0

    .line 537
    .local v0, batteryInfoService:Landroid/os/IBinder;
    if-nez v0, :cond_f

    .line 571
    :cond_e
    :goto_e
    return-void

    .line 539
    :cond_f
    iget-object v7, p0, Lcom/android/server/BatteryService;->mContext:Landroid/content/Context;

    const-string v8, "dropbox"

    invoke-virtual {v7, v8}, Landroid/content/Context;->getSystemService(Ljava/lang/String;)Ljava/lang/Object;

    move-result-object v1

    check-cast v1, Landroid/os/DropBoxManager;

    .line 540
    .local v1, db:Landroid/os/DropBoxManager;
    if-eqz v1, :cond_e

    const-string v7, "BATTERY_DISCHARGE_INFO"

    invoke-virtual {v1, v9}, Landroid/os/DropBoxManager;->isTagEnabled(Ljava/lang/String;)Z

    move-result v7

    if-eqz v7, :cond_e

    .line 542
    const/4 v2, 0x0

    .line 543
    .local v2, dumpFile:Ljava/io/File;
    const/4 v4, 0x0

    .line 546
    .local v4, dumpStream:Ljava/io/FileOutputStream;
    :try_start_25
    new-instance v3, Ljava/io/File;

    const-string v7, "/data/system/batteryinfo.dump"

    invoke-direct {v3, v7}, Ljava/io/File;-><init>(Ljava/lang/String;)V
    :try_end_2c
    .catchall {:try_start_25 .. :try_end_2c} :catchall_f6
    .catch Landroid/os/RemoteException; {:try_start_25 .. :try_end_2c} :catch_7c
    .catch Ljava/io/IOException; {:try_start_25 .. :try_end_2c} :catch_b9

    .line 547
    .end local v2           #dumpFile:Ljava/io/File;
    .local v3, dumpFile:Ljava/io/File;
    :try_start_2c
    new-instance v5, Ljava/io/FileOutputStream;

    invoke-direct {v5, v3}, Ljava/io/FileOutputStream;-><init>(Ljava/io/File;)V
    :try_end_31
    .catchall {:try_start_2c .. :try_end_31} :catchall_12a
    .catch Landroid/os/RemoteException; {:try_start_2c .. :try_end_31} :catch_13a
    .catch Ljava/io/IOException; {:try_start_2c .. :try_end_31} :catch_131

    .line 548
    .end local v4           #dumpStream:Ljava/io/FileOutputStream;
    .local v5, dumpStream:Ljava/io/FileOutputStream;
    :try_start_31
    invoke-virtual {v5}, Ljava/io/FileOutputStream;->getFD()Ljava/io/FileDescriptor;

    move-result-object v7

    sget-object v8, Lcom/android/server/BatteryService;->DUMPSYS_ARGS:[Ljava/lang/String;

    invoke-interface {v0, v7, v8}, Landroid/os/IBinder;->dump(Ljava/io/FileDescriptor;[Ljava/lang/String;)V

    .line 549
    invoke-virtual {v5}, Ljava/io/FileOutputStream;->getFD()Ljava/io/FileDescriptor;

    move-result-object v7

    invoke-virtual {v7}, Ljava/io/FileDescriptor;->sync()V

    .line 552
    const-string v7, "BATTERY_DISCHARGE_INFO"

    const/4 v8, 0x2

    invoke-virtual {v1, v7, v3, v8}, Landroid/os/DropBoxManager;->addFile(Ljava/lang/String;Ljava/io/File;I)V
    :try_end_47
    .catchall {:try_start_31 .. :try_end_47} :catchall_12d
    .catch Landroid/os/RemoteException; {:try_start_31 .. :try_end_47} :catch_13f
    .catch Ljava/io/IOException; {:try_start_31 .. :try_end_47} :catch_135

    .line 559
    if-eqz v5, :cond_4c

    .line 561
    :try_start_49
    invoke-virtual {v5}, Ljava/io/FileOutputStream;->close()V
    :try_end_4c
    .catch Ljava/io/IOException; {:try_start_49 .. :try_end_4c} :catch_73

    .line 566
    :cond_4c
    :goto_4c
    if-eqz v3, :cond_145

    invoke-virtual {v3}, Ljava/io/File;->delete()Z

    move-result v7

    if-nez v7, :cond_145

    .line 567
    sget-object v7, Lcom/android/server/BatteryService;->TAG:Ljava/lang/String;

    new-instance v8, Ljava/lang/StringBuilder;

    invoke-direct {v8}, Ljava/lang/StringBuilder;-><init>()V

    const-string v9, "failed to delete temporary dumpsys file: "

    invoke-virtual {v8, v11}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v8

    invoke-virtual {v3}, Ljava/io/File;->getAbsolutePath()Ljava/lang/String;

    move-result-object v9

    invoke-virtual {v8, v9}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v8

    invoke-virtual {v8}, Ljava/lang/StringBuilder;->toString()Ljava/lang/String;

    move-result-object v8

    invoke-static {v7, v8}, Landroid/util/Slog;->e(Ljava/lang/String;Ljava/lang/String;)I

    move-object v4, v5

    .end local v5           #dumpStream:Ljava/io/FileOutputStream;
    .restart local v4       #dumpStream:Ljava/io/FileOutputStream;
    move-object v2, v3

    .end local v3           #dumpFile:Ljava/io/File;
    .restart local v2       #dumpFile:Ljava/io/File;
    goto :goto_e

    .line 562
    .end local v2           #dumpFile:Ljava/io/File;
    .end local v4           #dumpStream:Ljava/io/FileOutputStream;
    .restart local v3       #dumpFile:Ljava/io/File;
    .restart local v5       #dumpStream:Ljava/io/FileOutputStream;
    :catch_73
    move-exception v6

    .line 563
    .local v6, e:Ljava/io/IOException;
    sget-object v7, Lcom/android/server/BatteryService;->TAG:Ljava/lang/String;

    const-string v8, "failed to close dumpsys output stream"

    invoke-static {v7, v10}, Landroid/util/Slog;->e(Ljava/lang/String;Ljava/lang/String;)I

    goto :goto_4c

    .line 553
    .end local v3           #dumpFile:Ljava/io/File;
    .end local v5           #dumpStream:Ljava/io/FileOutputStream;
    .end local v6           #e:Ljava/io/IOException;
    .restart local v2       #dumpFile:Ljava/io/File;
    .restart local v4       #dumpStream:Ljava/io/FileOutputStream;
    :catch_7c
    move-exception v7

    move-object v6, v7

    .line 554
    .local v6, e:Landroid/os/RemoteException;
    :goto_7e
    :try_start_7e
    sget-object v7, Lcom/android/server/BatteryService;->TAG:Ljava/lang/String;

    const-string v8, "failed to dump battery service"

    invoke-static {v7, v8, v6}, Landroid/util/Slog;->e(Ljava/lang/String;Ljava/lang/String;Ljava/lang/Throwable;)I
    :try_end_85
    .catchall {:try_start_7e .. :try_end_85} :catchall_f6

    .line 559
    if-eqz v4, :cond_8a

    .line 561
    :try_start_87
    invoke-virtual {v4}, Ljava/io/FileOutputStream;->close()V
    :try_end_8a
    .catch Ljava/io/IOException; {:try_start_87 .. :try_end_8a} :catch_b0

    .line 566
    .end local v6           #e:Landroid/os/RemoteException;
    :cond_8a
    :goto_8a
    if-eqz v2, :cond_e

    invoke-virtual {v2}, Ljava/io/File;->delete()Z

    move-result v7

    if-nez v7, :cond_e

    .line 567
    sget-object v7, Lcom/android/server/BatteryService;->TAG:Ljava/lang/String;

    new-instance v8, Ljava/lang/StringBuilder;

    invoke-direct {v8}, Ljava/lang/StringBuilder;-><init>()V

    const-string v9, "failed to delete temporary dumpsys file: "

    invoke-virtual {v8, v11}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v8

    invoke-virtual {v2}, Ljava/io/File;->getAbsolutePath()Ljava/lang/String;

    move-result-object v9

    invoke-virtual {v8, v9}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v8

    invoke-virtual {v8}, Ljava/lang/StringBuilder;->toString()Ljava/lang/String;

    move-result-object v8

    invoke-static {v7, v8}, Landroid/util/Slog;->e(Ljava/lang/String;Ljava/lang/String;)I

    goto/16 :goto_e

    .line 562
    .restart local v6       #e:Landroid/os/RemoteException;
    :catch_b0
    move-exception v6

    .line 563
    .local v6, e:Ljava/io/IOException;
    sget-object v7, Lcom/android/server/BatteryService;->TAG:Ljava/lang/String;

    const-string v8, "failed to close dumpsys output stream"

    invoke-static {v7, v10}, Landroid/util/Slog;->e(Ljava/lang/String;Ljava/lang/String;)I

    goto :goto_8a

    .line 555
    .end local v6           #e:Ljava/io/IOException;
    :catch_b9
    move-exception v7

    move-object v6, v7

    .line 556
    .restart local v6       #e:Ljava/io/IOException;
    :goto_bb
    :try_start_bb
    sget-object v7, Lcom/android/server/BatteryService;->TAG:Ljava/lang/String;

    const-string v8, "failed to write dumpsys file"

    invoke-static {v7, v8, v6}, Landroid/util/Slog;->e(Ljava/lang/String;Ljava/lang/String;Ljava/lang/Throwable;)I
    :try_end_c2
    .catchall {:try_start_bb .. :try_end_c2} :catchall_f6

    .line 559
    if-eqz v4, :cond_c7

    .line 561
    :try_start_c4
    invoke-virtual {v4}, Ljava/io/FileOutputStream;->close()V
    :try_end_c7
    .catch Ljava/io/IOException; {:try_start_c4 .. :try_end_c7} :catch_ed

    .line 566
    :cond_c7
    :goto_c7
    if-eqz v2, :cond_e

    invoke-virtual {v2}, Ljava/io/File;->delete()Z

    move-result v7

    if-nez v7, :cond_e

    .line 567
    sget-object v7, Lcom/android/server/BatteryService;->TAG:Ljava/lang/String;

    new-instance v8, Ljava/lang/StringBuilder;

    invoke-direct {v8}, Ljava/lang/StringBuilder;-><init>()V

    const-string v9, "failed to delete temporary dumpsys file: "

    invoke-virtual {v8, v11}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v8

    invoke-virtual {v2}, Ljava/io/File;->getAbsolutePath()Ljava/lang/String;

    move-result-object v9

    invoke-virtual {v8, v9}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v8

    invoke-virtual {v8}, Ljava/lang/StringBuilder;->toString()Ljava/lang/String;

    move-result-object v8

    invoke-static {v7, v8}, Landroid/util/Slog;->e(Ljava/lang/String;Ljava/lang/String;)I

    goto/16 :goto_e

    .line 562
    :catch_ed
    move-exception v6

    .line 563
    sget-object v7, Lcom/android/server/BatteryService;->TAG:Ljava/lang/String;

    const-string v8, "failed to close dumpsys output stream"

    invoke-static {v7, v10}, Landroid/util/Slog;->e(Ljava/lang/String;Ljava/lang/String;)I

    goto :goto_c7

    .line 559
    .end local v6           #e:Ljava/io/IOException;
    :catchall_f6
    move-exception v7

    :goto_f7
    if-eqz v4, :cond_fc

    .line 561
    :try_start_f9
    invoke-virtual {v4}, Ljava/io/FileOutputStream;->close()V
    :try_end_fc
    .catch Ljava/io/IOException; {:try_start_f9 .. :try_end_fc} :catch_121

    .line 566
    :cond_fc
    :goto_fc
    if-eqz v2, :cond_120

    invoke-virtual {v2}, Ljava/io/File;->delete()Z

    move-result v8

    if-nez v8, :cond_120

    .line 567
    sget-object v8, Lcom/android/server/BatteryService;->TAG:Ljava/lang/String;

    new-instance v9, Ljava/lang/StringBuilder;

    invoke-direct {v9}, Ljava/lang/StringBuilder;-><init>()V

    const-string v10, "failed to delete temporary dumpsys file: "

    invoke-virtual {v9, v11}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v9

    invoke-virtual {v2}, Ljava/io/File;->getAbsolutePath()Ljava/lang/String;

    move-result-object v10

    invoke-virtual {v9, v10}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v9

    invoke-virtual {v9}, Ljava/lang/StringBuilder;->toString()Ljava/lang/String;

    move-result-object v9

    invoke-static {v8, v9}, Landroid/util/Slog;->e(Ljava/lang/String;Ljava/lang/String;)I

    :cond_120
    throw v7

    .line 562
    :catch_121
    move-exception v6

    .line 563
    .restart local v6       #e:Ljava/io/IOException;
    sget-object v8, Lcom/android/server/BatteryService;->TAG:Ljava/lang/String;

    const-string v9, "failed to close dumpsys output stream"

    invoke-static {v8, v10}, Landroid/util/Slog;->e(Ljava/lang/String;Ljava/lang/String;)I

    goto :goto_fc

    .line 559
    .end local v2           #dumpFile:Ljava/io/File;
    .end local v6           #e:Ljava/io/IOException;
    .restart local v3       #dumpFile:Ljava/io/File;
    :catchall_12a
    move-exception v7

    move-object v2, v3

    .end local v3           #dumpFile:Ljava/io/File;
    .restart local v2       #dumpFile:Ljava/io/File;
    goto :goto_f7

    .end local v2           #dumpFile:Ljava/io/File;
    .end local v4           #dumpStream:Ljava/io/FileOutputStream;
    .restart local v3       #dumpFile:Ljava/io/File;
    .restart local v5       #dumpStream:Ljava/io/FileOutputStream;
    :catchall_12d
    move-exception v7

    move-object v4, v5

    .end local v5           #dumpStream:Ljava/io/FileOutputStream;
    .restart local v4       #dumpStream:Ljava/io/FileOutputStream;
    move-object v2, v3

    .end local v3           #dumpFile:Ljava/io/File;
    .restart local v2       #dumpFile:Ljava/io/File;
    goto :goto_f7

    .line 555
    .end local v2           #dumpFile:Ljava/io/File;
    .restart local v3       #dumpFile:Ljava/io/File;
    :catch_131
    move-exception v7

    move-object v6, v7

    move-object v2, v3

    .end local v3           #dumpFile:Ljava/io/File;
    .restart local v2       #dumpFile:Ljava/io/File;
    goto :goto_bb

    .end local v2           #dumpFile:Ljava/io/File;
    .end local v4           #dumpStream:Ljava/io/FileOutputStream;
    .restart local v3       #dumpFile:Ljava/io/File;
    .restart local v5       #dumpStream:Ljava/io/FileOutputStream;
    :catch_135
    move-exception v7

    move-object v6, v7

    move-object v4, v5

    .end local v5           #dumpStream:Ljava/io/FileOutputStream;
    .restart local v4       #dumpStream:Ljava/io/FileOutputStream;
    move-object v2, v3

    .end local v3           #dumpFile:Ljava/io/File;
    .restart local v2       #dumpFile:Ljava/io/File;
    goto :goto_bb

    .line 553
    .end local v2           #dumpFile:Ljava/io/File;
    .restart local v3       #dumpFile:Ljava/io/File;
    :catch_13a
    move-exception v7

    move-object v6, v7

    move-object v2, v3

    .end local v3           #dumpFile:Ljava/io/File;
    .restart local v2       #dumpFile:Ljava/io/File;
    goto/16 :goto_7e

    .end local v2           #dumpFile:Ljava/io/File;
    .end local v4           #dumpStream:Ljava/io/FileOutputStream;
    .restart local v3       #dumpFile:Ljava/io/File;
    .restart local v5       #dumpStream:Ljava/io/FileOutputStream;
    :catch_13f
    move-exception v7

    move-object v6, v7

    move-object v4, v5

    .end local v5           #dumpStream:Ljava/io/FileOutputStream;
    .restart local v4       #dumpStream:Ljava/io/FileOutputStream;
    move-object v2, v3

    .end local v3           #dumpFile:Ljava/io/File;
    .restart local v2       #dumpFile:Ljava/io/File;
    goto/16 :goto_7e

    .end local v2           #dumpFile:Ljava/io/File;
    .end local v4           #dumpStream:Ljava/io/FileOutputStream;
    .restart local v3       #dumpFile:Ljava/io/File;
    .restart local v5       #dumpStream:Ljava/io/FileOutputStream;
    :cond_145
    move-object v4, v5

    .end local v5           #dumpStream:Ljava/io/FileOutputStream;
    .restart local v4       #dumpStream:Ljava/io/FileOutputStream;
    move-object v2, v3

    .end local v3           #dumpFile:Ljava/io/File;
    .restart local v2       #dumpFile:Ljava/io/File;
    goto/16 :goto_e
.end method

.method private final logOutlier(J)V
    .registers 13
    .parameter "duration"

    .prologue
    .line 574
    iget-object v7, p0, Lcom/android/server/BatteryService;->mContext:Landroid/content/Context;

    invoke-virtual {v7}, Landroid/content/Context;->getContentResolver()Landroid/content/ContentResolver;

    move-result-object v0

    .line 575
    .local v0, cr:Landroid/content/ContentResolver;
    const-string v7, "battery_discharge_threshold"

    invoke-static {v0, v7}, Landroid/provider/Settings$Secure;->getString(Landroid/content/ContentResolver;Ljava/lang/String;)Ljava/lang/String;

    move-result-object v2

    .line 577
    .local v2, dischargeThresholdString:Ljava/lang/String;
    const-string v7, "battery_discharge_duration_threshold"

    invoke-static {v0, v7}, Landroid/provider/Settings$Secure;->getString(Landroid/content/ContentResolver;Ljava/lang/String;)Ljava/lang/String;

    move-result-object v5

    .line 580
    .local v5, durationThresholdString:Ljava/lang/String;
    if-eqz v2, :cond_2c

    if-eqz v5, :cond_2c

    .line 582
    :try_start_16
    invoke-static {v5}, Ljava/lang/Long;->parseLong(Ljava/lang/String;)J

    move-result-wide v3

    .line 583
    .local v3, durationThreshold:J
    invoke-static {v2}, Ljava/lang/Integer;->parseInt(Ljava/lang/String;)I

    move-result v1

    .line 584
    .local v1, dischargeThreshold:I
    cmp-long v7, p1, v3

    if-gtz v7, :cond_2c

    iget v7, p0, Lcom/android/server/BatteryService;->mDischargeStartLevel:I

    iget v8, p0, Lcom/android/server/BatteryService;->mBatteryLevel:I

    sub-int/2addr v7, v8

    if-lt v7, v1, :cond_2c

    .line 587
    invoke-direct {p0}, Lcom/android/server/BatteryService;->logBatteryStats()V
    :try_end_2c
    .catch Ljava/lang/NumberFormatException; {:try_start_16 .. :try_end_2c} :catch_2d

    .line 599
    .end local v1           #dischargeThreshold:I
    .end local v3           #durationThreshold:J
    :cond_2c
    :goto_2c
    return-void

    .line 593
    :catch_2d
    move-exception v7

    move-object v6, v7

    .line 594
    .local v6, e:Ljava/lang/NumberFormatException;
    sget-object v7, Lcom/android/server/BatteryService;->TAG:Ljava/lang/String;

    new-instance v8, Ljava/lang/StringBuilder;

    invoke-direct {v8}, Ljava/lang/StringBuilder;-><init>()V

    const-string v9, "Invalid DischargeThresholds GService string: "

    invoke-virtual {v8, v9}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v8

    invoke-virtual {v8, v5}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v8

    const-string v9, " or "

    invoke-virtual {v8, v9}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v8

    invoke-virtual {v8, v2}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v8

    invoke-virtual {v8}, Ljava/lang/StringBuilder;->toString()Ljava/lang/String;

    move-result-object v8

    invoke-static {v7, v8}, Landroid/util/Slog;->e(Ljava/lang/String;Ljava/lang/String;)I

    goto :goto_2c
.end method

.method private native native_update()V
.end method

.method private readFile(Ljava/lang/String;)Ljava/lang/String;
    .registers 14
    .parameter "fn"

    .prologue
    const-string v11, "read property /sys/devices/platform/msm_hsusb/"

    const-string v10, " failed"

    const-string v9, ""

    .line 455
    const/4 v3, 0x0

    .line 456
    .local v3, fr:Ljava/io/FileReader;
    const/4 v0, 0x0

    .line 458
    .local v0, br:Ljava/io/BufferedReader;
    :try_start_8
    new-instance v4, Ljava/io/FileReader;

    new-instance v6, Ljava/lang/StringBuilder;

    invoke-direct {v6}, Ljava/lang/StringBuilder;-><init>()V

    const-string v7, "/sys/devices/platform/msm_hsusb/"

    invoke-virtual {v6, v7}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v6

    invoke-virtual {v6, p1}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v6

    invoke-virtual {v6}, Ljava/lang/StringBuilder;->toString()Ljava/lang/String;

    move-result-object v6

    invoke-direct {v4, v6}, Ljava/io/FileReader;-><init>(Ljava/lang/String;)V
    :try_end_20
    .catchall {:try_start_8 .. :try_end_20} :catchall_a1
    .catch Ljava/io/IOException; {:try_start_8 .. :try_end_20} :catch_6a

    .line 459
    .end local v3           #fr:Ljava/io/FileReader;
    .local v4, fr:Ljava/io/FileReader;
    if-eqz v4, :cond_28

    .line 460
    :try_start_22
    new-instance v1, Ljava/io/BufferedReader;

    invoke-direct {v1, v4}, Ljava/io/BufferedReader;-><init>(Ljava/io/Reader;)V

    .end local v0           #br:Ljava/io/BufferedReader;
    .local v1, br:Ljava/io/BufferedReader;
    move-object v0, v1

    .line 462
    .end local v1           #br:Ljava/io/BufferedReader;
    .restart local v0       #br:Ljava/io/BufferedReader;
    :cond_28
    if-eqz v0, :cond_3d

    invoke-virtual {v0}, Ljava/io/BufferedReader;->readLine()Ljava/lang/String;
    :try_end_2d
    .catchall {:try_start_22 .. :try_end_2d} :catchall_bd
    .catch Ljava/io/IOException; {:try_start_22 .. :try_end_2d} :catch_c0

    move-result-object v5

    .local v5, line:Ljava/lang/String;
    if-eqz v5, :cond_3d

    .line 474
    if-eqz v0, :cond_35

    .line 475
    :try_start_32
    invoke-virtual {v0}, Ljava/io/BufferedReader;->close()V
    :try_end_35
    .catch Ljava/io/IOException; {:try_start_32 .. :try_end_35} :catch_ad

    .line 479
    :cond_35
    :goto_35
    if-eqz v4, :cond_3a

    .line 480
    :try_start_37
    invoke-virtual {v4}, Ljava/io/FileReader;->close()V
    :try_end_3a
    .catch Ljava/io/IOException; {:try_start_37 .. :try_end_3a} :catch_af

    :cond_3a
    :goto_3a
    move-object v3, v4

    .end local v4           #fr:Ljava/io/FileReader;
    .restart local v3       #fr:Ljava/io/FileReader;
    move-object v6, v5

    .line 486
    .end local v5           #line:Ljava/lang/String;
    :goto_3c
    return-object v6

    .line 466
    .end local v3           #fr:Ljava/io/FileReader;
    .restart local v4       #fr:Ljava/io/FileReader;
    :cond_3d
    :try_start_3d
    sget-object v6, Lcom/android/server/BatteryService;->TAG:Ljava/lang/String;

    new-instance v7, Ljava/lang/StringBuilder;

    invoke-direct {v7}, Ljava/lang/StringBuilder;-><init>()V

    const-string v8, "read property /sys/devices/platform/msm_hsusb/"

    invoke-virtual {v7, v8}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v7

    invoke-virtual {v7, p1}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v7

    const-string v8, " failed"

    invoke-virtual {v7, v8}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v7

    invoke-virtual {v7}, Ljava/lang/StringBuilder;->toString()Ljava/lang/String;

    move-result-object v7

    invoke-static {v6, v7}, Landroid/util/Log;->e(Ljava/lang/String;Ljava/lang/String;)I

    .line 468
    const-string v6, ""
    :try_end_5d
    .catchall {:try_start_3d .. :try_end_5d} :catchall_bd
    .catch Ljava/io/IOException; {:try_start_3d .. :try_end_5d} :catch_c0

    .line 474
    if-eqz v0, :cond_62

    .line 475
    :try_start_5f
    invoke-virtual {v0}, Ljava/io/BufferedReader;->close()V
    :try_end_62
    .catch Ljava/io/IOException; {:try_start_5f .. :try_end_62} :catch_b1

    .line 479
    :cond_62
    :goto_62
    if-eqz v4, :cond_67

    .line 480
    :try_start_64
    invoke-virtual {v4}, Ljava/io/FileReader;->close()V
    :try_end_67
    .catch Ljava/io/IOException; {:try_start_64 .. :try_end_67} :catch_b3

    :cond_67
    :goto_67
    move-object v3, v4

    .end local v4           #fr:Ljava/io/FileReader;
    .restart local v3       #fr:Ljava/io/FileReader;
    move-object v6, v9

    .line 482
    goto :goto_3c

    .line 470
    :catch_6a
    move-exception v6

    move-object v2, v6

    .line 471
    .local v2, ex:Ljava/io/IOException;
    :goto_6c
    :try_start_6c
    sget-object v6, Lcom/android/server/BatteryService;->TAG:Ljava/lang/String;

    invoke-virtual {v2}, Ljava/io/IOException;->getMessage()Ljava/lang/String;

    move-result-object v7

    invoke-static {v6, v7}, Landroid/util/Log;->e(Ljava/lang/String;Ljava/lang/String;)I
    :try_end_75
    .catchall {:try_start_6c .. :try_end_75} :catchall_a1

    .line 474
    if-eqz v0, :cond_7a

    .line 475
    :try_start_77
    invoke-virtual {v0}, Ljava/io/BufferedReader;->close()V
    :try_end_7a
    .catch Ljava/io/IOException; {:try_start_77 .. :try_end_7a} :catch_b5

    .line 479
    :cond_7a
    :goto_7a
    if-eqz v3, :cond_7f

    .line 480
    :try_start_7c
    invoke-virtual {v3}, Ljava/io/FileReader;->close()V
    :try_end_7f
    .catch Ljava/io/IOException; {:try_start_7c .. :try_end_7f} :catch_b7

    .line 484
    :cond_7f
    :goto_7f
    sget-object v6, Lcom/android/server/BatteryService;->TAG:Ljava/lang/String;

    new-instance v7, Ljava/lang/StringBuilder;

    invoke-direct {v7}, Ljava/lang/StringBuilder;-><init>()V

    const-string v8, "read property /sys/devices/platform/msm_hsusb/"

    invoke-virtual {v7, v11}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v7

    invoke-virtual {v7, p1}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v7

    const-string v8, " failed"

    invoke-virtual {v7, v10}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v7

    invoke-virtual {v7}, Ljava/lang/StringBuilder;->toString()Ljava/lang/String;

    move-result-object v7

    invoke-static {v6, v7}, Landroid/util/Log;->e(Ljava/lang/String;Ljava/lang/String;)I

    .line 486
    const-string v6, ""

    move-object v6, v9

    goto :goto_3c

    .line 473
    .end local v2           #ex:Ljava/io/IOException;
    :catchall_a1
    move-exception v6

    .line 474
    :goto_a2
    if-eqz v0, :cond_a7

    .line 475
    :try_start_a4
    invoke-virtual {v0}, Ljava/io/BufferedReader;->close()V
    :try_end_a7
    .catch Ljava/io/IOException; {:try_start_a4 .. :try_end_a7} :catch_b9

    .line 479
    :cond_a7
    :goto_a7
    if-eqz v3, :cond_ac

    .line 480
    :try_start_a9
    invoke-virtual {v3}, Ljava/io/FileReader;->close()V
    :try_end_ac
    .catch Ljava/io/IOException; {:try_start_a9 .. :try_end_ac} :catch_bb

    .line 482
    :cond_ac
    :goto_ac
    throw v6

    .line 476
    .end local v3           #fr:Ljava/io/FileReader;
    .restart local v4       #fr:Ljava/io/FileReader;
    .restart local v5       #line:Ljava/lang/String;
    :catch_ad
    move-exception v6

    goto :goto_35

    .line 481
    :catch_af
    move-exception v6

    goto :goto_3a

    .line 476
    .end local v5           #line:Ljava/lang/String;
    :catch_b1
    move-exception v6

    goto :goto_62

    .line 481
    :catch_b3
    move-exception v6

    goto :goto_67

    .line 476
    .end local v4           #fr:Ljava/io/FileReader;
    .restart local v2       #ex:Ljava/io/IOException;
    .restart local v3       #fr:Ljava/io/FileReader;
    :catch_b5
    move-exception v6

    goto :goto_7a

    .line 481
    :catch_b7
    move-exception v6

    goto :goto_7f

    .line 476
    .end local v2           #ex:Ljava/io/IOException;
    :catch_b9
    move-exception v7

    goto :goto_a7

    .line 481
    :catch_bb
    move-exception v7

    goto :goto_ac

    .line 473
    .end local v3           #fr:Ljava/io/FileReader;
    .restart local v4       #fr:Ljava/io/FileReader;
    :catchall_bd
    move-exception v6

    move-object v3, v4

    .end local v4           #fr:Ljava/io/FileReader;
    .restart local v3       #fr:Ljava/io/FileReader;
    goto :goto_a2

    .line 470
    .end local v3           #fr:Ljava/io/FileReader;
    .restart local v4       #fr:Ljava/io/FileReader;
    :catch_c0
    move-exception v6

    move-object v2, v6

    move-object v3, v4

    .end local v4           #fr:Ljava/io/FileReader;
    .restart local v3       #fr:Ljava/io/FileReader;
    goto :goto_6c
.end method

.method private final sendIntent()V
    .registers 7

    .prologue
    const/4 v5, 0x1

    .line 490
    new-instance v1, Landroid/content/Intent;

    const-string v2, "android.intent.action.BATTERY_CHANGED"

    invoke-direct {v1, v2}, Landroid/content/Intent;-><init>(Ljava/lang/String;)V

    .line 491
    .local v1, intent:Landroid/content/Intent;
    const/high16 v2, 0x6000

    invoke-virtual {v1, v2}, Landroid/content/Intent;->addFlags(I)Landroid/content/Intent;

    .line 494
    :try_start_d
    iget-object v2, p0, Lcom/android/server/BatteryService;->mBatteryStats:Lcom/android/internal/app/IBatteryStats;

    iget v3, p0, Lcom/android/server/BatteryService;->mPlugType:I

    if-nez v3, :cond_6a

    move v3, v5

    :goto_14
    iget v4, p0, Lcom/android/server/BatteryService;->mBatteryLevel:I

    invoke-interface {v2, v3, v4}, Lcom/android/internal/app/IBatteryStats;->setOnBattery(ZI)V
    :try_end_19
    .catch Landroid/os/RemoteException; {:try_start_d .. :try_end_19} :catch_6c

    .line 499
    :goto_19
    iget v2, p0, Lcom/android/server/BatteryService;->mBatteryLevel:I

    invoke-direct {p0, v2}, Lcom/android/server/BatteryService;->getIcon(I)I

    move-result v0

    .line 501
    .local v0, icon:I
    const-string v2, "status"

    iget v3, p0, Lcom/android/server/BatteryService;->mBatteryStatus:I

    invoke-virtual {v1, v2, v3}, Landroid/content/Intent;->putExtra(Ljava/lang/String;I)Landroid/content/Intent;

    .line 502
    const-string v2, "health"

    iget v3, p0, Lcom/android/server/BatteryService;->mBatteryHealth:I

    invoke-virtual {v1, v2, v3}, Landroid/content/Intent;->putExtra(Ljava/lang/String;I)Landroid/content/Intent;

    .line 503
    const-string v2, "present"

    iget-boolean v3, p0, Lcom/android/server/BatteryService;->mBatteryPresent:Z

    invoke-virtual {v1, v2, v3}, Landroid/content/Intent;->putExtra(Ljava/lang/String;Z)Landroid/content/Intent;

    .line 504
    const-string v2, "level"

    iget v3, p0, Lcom/android/server/BatteryService;->mBatteryLevel:I

    invoke-virtual {v1, v2, v3}, Landroid/content/Intent;->putExtra(Ljava/lang/String;I)Landroid/content/Intent;

    .line 505
    const-string v2, "scale"

    const/16 v3, 0x64

    invoke-virtual {v1, v2, v3}, Landroid/content/Intent;->putExtra(Ljava/lang/String;I)Landroid/content/Intent;

    .line 506
    const-string v2, "icon-small"

    invoke-virtual {v1, v2, v0}, Landroid/content/Intent;->putExtra(Ljava/lang/String;I)Landroid/content/Intent;

    .line 507
    const-string v2, "plugged"

    iget v3, p0, Lcom/android/server/BatteryService;->mPlugType:I

    invoke-virtual {v1, v2, v3}, Landroid/content/Intent;->putExtra(Ljava/lang/String;I)Landroid/content/Intent;

    .line 508
    const-string v2, "voltage"

    iget v3, p0, Lcom/android/server/BatteryService;->mBatteryVoltage:I

    invoke-virtual {v1, v2, v3}, Landroid/content/Intent;->putExtra(Ljava/lang/String;I)Landroid/content/Intent;

    .line 509
    const-string v2, "temperature"

    iget v3, p0, Lcom/android/server/BatteryService;->mBatteryTemperature:I

    invoke-virtual {v1, v2, v3}, Landroid/content/Intent;->putExtra(Ljava/lang/String;I)Landroid/content/Intent;

    .line 510
    const-string v2, "technology"

    iget-object v3, p0, Lcom/android/server/BatteryService;->mBatteryTechnology:Ljava/lang/String;

    invoke-virtual {v1, v2, v3}, Landroid/content/Intent;->putExtra(Ljava/lang/String;Ljava/lang/String;)Landroid/content/Intent;

    .line 531
    const/4 v2, 0x0

    invoke-static {v1, v2}, Landroid/app/ActivityManagerNative;->broadcastStickyIntent(Landroid/content/Intent;Ljava/lang/String;)V

    .line 532
    iput-boolean v5, p0, Lcom/android/server/BatteryService;->isBroadcsatBatteryIntent:Z

    .line 533
    return-void

    .line 494
    .end local v0           #icon:I
    :cond_6a
    const/4 v3, 0x0

    goto :goto_14

    .line 495
    :catch_6c
    move-exception v2

    goto :goto_19
.end method

.method private final shutdownIfNoPower()V
    .registers 4

    .prologue
    .line 200
    iget v1, p0, Lcom/android/server/BatteryService;->mBatteryLevel:I

    if-nez v1, :cond_27

    invoke-virtual {p0}, Lcom/android/server/BatteryService;->isPowered()Z

    move-result v1

    if-nez v1, :cond_27

    invoke-static {}, Landroid/app/ActivityManagerNative;->isSystemReady()Z

    move-result v1

    if-eqz v1, :cond_27

    .line 201
    new-instance v0, Landroid/content/Intent;

    const-string v1, "android.intent.action.ACTION_REQUEST_SHUTDOWN"

    invoke-direct {v0, v1}, Landroid/content/Intent;-><init>(Ljava/lang/String;)V

    .line 202
    .local v0, intent:Landroid/content/Intent;
    const-string v1, "android.intent.extra.KEY_CONFIRM"

    const/4 v2, 0x0

    invoke-virtual {v0, v1, v2}, Landroid/content/Intent;->putExtra(Ljava/lang/String;Z)Landroid/content/Intent;

    .line 203
    const/high16 v1, 0x1000

    invoke-virtual {v0, v1}, Landroid/content/Intent;->setFlags(I)Landroid/content/Intent;

    .line 204
    iget-object v1, p0, Lcom/android/server/BatteryService;->mContext:Landroid/content/Context;

    invoke-virtual {v1, v0}, Landroid/content/Context;->startActivity(Landroid/content/Intent;)V

    .line 206
    .end local v0           #intent:Landroid/content/Intent;
    :cond_27
    return-void
.end method

.method private final shutdownIfOverTemp()V
    .registers 4

    .prologue
    .line 211
    iget v1, p0, Lcom/android/server/BatteryService;->mBatteryTemperature:I

    const/16 v2, 0x2a8

    if-le v1, v2, :cond_23

    invoke-static {}, Landroid/app/ActivityManagerNative;->isSystemReady()Z

    move-result v1

    if-eqz v1, :cond_23

    .line 212
    new-instance v0, Landroid/content/Intent;

    const-string v1, "android.intent.action.ACTION_REQUEST_SHUTDOWN"

    invoke-direct {v0, v1}, Landroid/content/Intent;-><init>(Ljava/lang/String;)V

    .line 213
    .local v0, intent:Landroid/content/Intent;
    const-string v1, "android.intent.extra.KEY_CONFIRM"

    const/4 v2, 0x0

    invoke-virtual {v0, v1, v2}, Landroid/content/Intent;->putExtra(Ljava/lang/String;Z)Landroid/content/Intent;

    .line 214
    const/high16 v1, 0x1000

    invoke-virtual {v0, v1}, Landroid/content/Intent;->setFlags(I)Landroid/content/Intent;

    .line 215
    iget-object v1, p0, Lcom/android/server/BatteryService;->mContext:Landroid/content/Context;

    invoke-virtual {v1, v0}, Landroid/content/Context;->startActivity(Landroid/content/Intent;)V

    .line 217
    .end local v0           #intent:Landroid/content/Intent;
    :cond_23
    return-void
.end method

.method private final declared-synchronized update()V
    .registers 21

    .prologue
    .line 222
    monitor-enter p0

    :try_start_1
    invoke-direct/range {p0 .. p0}, Lcom/android/server/BatteryService;->native_update()V

    .line 239
    const/4 v8, 0x0

    .line 240
    .local v8, logOutlier:Z
    const-wide/16 v3, 0x0

    .line 242
    .local v3, dischargeDuration:J
    const/4 v14, 0x0

    .line 245
    .local v14, showUnsupportedChargerWarningFlag:Z
    invoke-direct/range {p0 .. p0}, Lcom/android/server/BatteryService;->shutdownIfNoPower()V

    .line 247
    invoke-direct/range {p0 .. p0}, Lcom/android/server/BatteryService;->shutdownIfOverTemp()V

    .line 249
    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryLevel:I

    move/from16 v16, v0

    const/16 v17, 0x4

    move/from16 v0, v16

    move/from16 v1, v17

    if-gt v0, v1, :cond_34b

    const/16 v16, 0x1

    :goto_1e
    move/from16 v0, v16

    move-object/from16 v1, p0

    iput-boolean v0, v1, Lcom/android/server/BatteryService;->mBatteryLevelCritical:Z

    .line 250
    move-object/from16 v0, p0

    iget-boolean v0, v0, Lcom/android/server/BatteryService;->mAcOnline:Z

    move/from16 v16, v0

    if-eqz v16, :cond_34f

    .line 251
    const/16 v16, 0x1

    move/from16 v0, v16

    move-object/from16 v1, p0

    iput v0, v1, Lcom/android/server/BatteryService;->mPlugType:I

    .line 257
    :goto_34
    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryStatus:I

    move/from16 v16, v0

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mLastBatteryStatus:I

    move/from16 v17, v0

    move/from16 v0, v16

    move/from16 v1, v17

    if-ne v0, v1, :cond_c4

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryHealth:I

    move/from16 v16, v0

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mLastBatteryHealth:I

    move/from16 v17, v0

    move/from16 v0, v16

    move/from16 v1, v17

    if-ne v0, v1, :cond_c4

    move-object/from16 v0, p0

    iget-boolean v0, v0, Lcom/android/server/BatteryService;->mBatteryPresent:Z

    move/from16 v16, v0

    move-object/from16 v0, p0

    iget-boolean v0, v0, Lcom/android/server/BatteryService;->mLastBatteryPresent:Z

    move/from16 v17, v0

    move/from16 v0, v16

    move/from16 v1, v17

    if-ne v0, v1, :cond_c4

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryLevel:I

    move/from16 v16, v0

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mLastBatteryLevel:I

    move/from16 v17, v0

    move/from16 v0, v16

    move/from16 v1, v17

    if-ne v0, v1, :cond_c4

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mPlugType:I

    move/from16 v16, v0

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mLastPlugType:I

    move/from16 v17, v0

    move/from16 v0, v16

    move/from16 v1, v17

    if-ne v0, v1, :cond_c4

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryVoltage:I

    move/from16 v16, v0

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mLastBatteryVoltage:I

    move/from16 v17, v0

    move/from16 v0, v16

    move/from16 v1, v17

    if-ne v0, v1, :cond_c4

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryTemperature:I

    move/from16 v16, v0

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mLastBatteryTemperature:I

    move/from16 v17, v0

    move/from16 v0, v16

    move/from16 v1, v17

    if-ne v0, v1, :cond_c4

    move-object/from16 v0, p0

    iget-boolean v0, v0, Lcom/android/server/BatteryService;->mUnsupportedCharger:Z

    move/from16 v16, v0

    move-object/from16 v0, p0

    iget-boolean v0, v0, Lcom/android/server/BatteryService;->mLastUnsupportedCharger:Z

    move/from16 v17, v0

    move/from16 v0, v16

    move/from16 v1, v17

    if-eq v0, v1, :cond_4cc

    .line 266
    :cond_c4
    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mPlugType:I

    move/from16 v16, v0

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mLastPlugType:I

    move/from16 v17, v0

    move/from16 v0, v16

    move/from16 v1, v17

    if-eq v0, v1, :cond_399

    .line 267
    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mLastPlugType:I

    move/from16 v16, v0

    if-nez v16, :cond_371

    .line 268
    move-object/from16 v0, p0

    iget-boolean v0, v0, Lcom/android/server/BatteryService;->mUnsupportedCharger:Z

    move/from16 v16, v0

    if-nez v16, :cond_36e

    .line 272
    move-object/from16 v0, p0

    iget-wide v0, v0, Lcom/android/server/BatteryService;->mDischargeStartTime:J

    move-wide/from16 v16, v0

    const-wide/16 v18, 0x0

    cmp-long v16, v16, v18

    if-eqz v16, :cond_14a

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mDischargeStartLevel:I

    move/from16 v16, v0

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryLevel:I

    move/from16 v17, v0

    move/from16 v0, v16

    move/from16 v1, v17

    if-eq v0, v1, :cond_14a

    .line 273
    invoke-static {}, Landroid/os/SystemClock;->elapsedRealtime()J

    move-result-wide v16

    move-object/from16 v0, p0

    iget-wide v0, v0, Lcom/android/server/BatteryService;->mDischargeStartTime:J

    move-wide/from16 v18, v0

    sub-long v3, v16, v18

    .line 274
    const/4 v8, 0x1

    .line 275
    const/16 v16, 0xaaa

    const/16 v17, 0x3

    move/from16 v0, v17

    new-array v0, v0, [Ljava/lang/Object;

    move-object/from16 v17, v0

    const/16 v18, 0x0

    invoke-static {v3, v4}, Ljava/lang/Long;->valueOf(J)Ljava/lang/Long;

    move-result-object v19

    aput-object v19, v17, v18

    const/16 v18, 0x1

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mDischargeStartLevel:I

    move/from16 v19, v0

    invoke-static/range {v19 .. v19}, Ljava/lang/Integer;->valueOf(I)Ljava/lang/Integer;

    move-result-object v19

    aput-object v19, v17, v18

    const/16 v18, 0x2

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryLevel:I

    move/from16 v19, v0

    invoke-static/range {v19 .. v19}, Ljava/lang/Integer;->valueOf(I)Ljava/lang/Integer;

    move-result-object v19

    aput-object v19, v17, v18

    invoke-static/range {v16 .. v17}, Landroid/util/EventLog;->writeEvent(I[Ljava/lang/Object;)I

    .line 278
    const-wide/16 v16, 0x0

    move-wide/from16 v0, v16

    move-object/from16 v2, p0

    iput-wide v0, v2, Lcom/android/server/BatteryService;->mDischargeStartTime:J

    .line 310
    :cond_14a
    :goto_14a
    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryStatus:I

    move/from16 v16, v0

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mLastBatteryStatus:I

    move/from16 v17, v0

    move/from16 v0, v16

    move/from16 v1, v17

    if-ne v0, v1, :cond_192

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryHealth:I

    move/from16 v16, v0

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mLastBatteryHealth:I

    move/from16 v17, v0

    move/from16 v0, v16

    move/from16 v1, v17

    if-ne v0, v1, :cond_192

    move-object/from16 v0, p0

    iget-boolean v0, v0, Lcom/android/server/BatteryService;->mBatteryPresent:Z

    move/from16 v16, v0

    move-object/from16 v0, p0

    iget-boolean v0, v0, Lcom/android/server/BatteryService;->mLastBatteryPresent:Z

    move/from16 v17, v0

    move/from16 v0, v16

    move/from16 v1, v17

    if-ne v0, v1, :cond_192

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mPlugType:I

    move/from16 v16, v0

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mLastPlugType:I

    move/from16 v17, v0

    move/from16 v0, v16

    move/from16 v1, v17

    if-eq v0, v1, :cond_1e5

    .line 314
    :cond_192
    const/16 v16, 0xaa3

    const/16 v17, 0x5

    move/from16 v0, v17

    new-array v0, v0, [Ljava/lang/Object;

    move-object/from16 v17, v0

    const/16 v18, 0x0

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryStatus:I

    move/from16 v19, v0

    invoke-static/range {v19 .. v19}, Ljava/lang/Integer;->valueOf(I)Ljava/lang/Integer;

    move-result-object v19

    aput-object v19, v17, v18

    const/16 v18, 0x1

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryHealth:I

    move/from16 v19, v0

    invoke-static/range {v19 .. v19}, Ljava/lang/Integer;->valueOf(I)Ljava/lang/Integer;

    move-result-object v19

    aput-object v19, v17, v18

    const/16 v18, 0x2

    move-object/from16 v0, p0

    iget-boolean v0, v0, Lcom/android/server/BatteryService;->mBatteryPresent:Z

    move/from16 v19, v0

    if-eqz v19, :cond_3bc

    const/16 v19, 0x1

    :goto_1c4
    invoke-static/range {v19 .. v19}, Ljava/lang/Integer;->valueOf(I)Ljava/lang/Integer;

    move-result-object v19

    aput-object v19, v17, v18

    const/16 v18, 0x3

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mPlugType:I

    move/from16 v19, v0

    invoke-static/range {v19 .. v19}, Ljava/lang/Integer;->valueOf(I)Ljava/lang/Integer;

    move-result-object v19

    aput-object v19, v17, v18

    const/16 v18, 0x4

    move-object/from16 v0, p0

    iget-object v0, v0, Lcom/android/server/BatteryService;->mBatteryTechnology:Ljava/lang/String;

    move-object/from16 v19, v0

    aput-object v19, v17, v18

    invoke-static/range {v16 .. v17}, Landroid/util/EventLog;->writeEvent(I[Ljava/lang/Object;)I

    .line 318
    :cond_1e5
    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryLevel:I

    move/from16 v16, v0

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mLastBatteryLevel:I

    move/from16 v17, v0

    move/from16 v0, v16

    move/from16 v1, v17

    if-ne v0, v1, :cond_21b

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryVoltage:I

    move/from16 v16, v0

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mLastBatteryVoltage:I

    move/from16 v17, v0

    move/from16 v0, v16

    move/from16 v1, v17

    if-ne v0, v1, :cond_21b

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryTemperature:I

    move/from16 v16, v0

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mLastBatteryTemperature:I

    move/from16 v17, v0

    move/from16 v0, v16

    move/from16 v1, v17

    if-eq v0, v1, :cond_252

    .line 321
    :cond_21b
    const/16 v16, 0xaa2

    const/16 v17, 0x3

    move/from16 v0, v17

    new-array v0, v0, [Ljava/lang/Object;

    move-object/from16 v17, v0

    const/16 v18, 0x0

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryLevel:I

    move/from16 v19, v0

    invoke-static/range {v19 .. v19}, Ljava/lang/Integer;->valueOf(I)Ljava/lang/Integer;

    move-result-object v19

    aput-object v19, v17, v18

    const/16 v18, 0x1

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryVoltage:I

    move/from16 v19, v0

    invoke-static/range {v19 .. v19}, Ljava/lang/Integer;->valueOf(I)Ljava/lang/Integer;

    move-result-object v19

    aput-object v19, v17, v18

    const/16 v18, 0x2

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryTemperature:I

    move/from16 v19, v0

    invoke-static/range {v19 .. v19}, Ljava/lang/Integer;->valueOf(I)Ljava/lang/Integer;

    move-result-object v19

    aput-object v19, v17, v18

    invoke-static/range {v16 .. v17}, Landroid/util/EventLog;->writeEvent(I[Ljava/lang/Object;)I

    .line 324
    :cond_252
    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryLevel:I

    move/from16 v16, v0

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mLastBatteryLevel:I

    move/from16 v17, v0

    move/from16 v0, v16

    move/from16 v1, v17

    if-eq v0, v1, :cond_27b

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mPlugType:I

    move/from16 v16, v0
    :try_end_26a
    .catchall {:try_start_1 .. :try_end_26a} :catchall_361

    if-nez v16, :cond_27b

    .line 329
    :try_start_26c
    move-object/from16 v0, p0

    iget-object v0, v0, Lcom/android/server/BatteryService;->mBatteryStats:Lcom/android/internal/app/IBatteryStats;

    move-object/from16 v16, v0

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryLevel:I

    move/from16 v17, v0

    invoke-interface/range {v16 .. v17}, Lcom/android/internal/app/IBatteryStats;->recordCurrentLevel(I)V
    :try_end_27b
    .catchall {:try_start_26c .. :try_end_27b} :catchall_361
    .catch Landroid/os/RemoteException; {:try_start_26c .. :try_end_27b} :catch_5e1

    .line 334
    :cond_27b
    :goto_27b
    :try_start_27b
    move-object/from16 v0, p0

    iget-boolean v0, v0, Lcom/android/server/BatteryService;->mBatteryLevelCritical:Z

    move/from16 v16, v0

    if-eqz v16, :cond_2a0

    move-object/from16 v0, p0

    iget-boolean v0, v0, Lcom/android/server/BatteryService;->mLastBatteryLevelCritical:Z

    move/from16 v16, v0

    if-nez v16, :cond_2a0

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mPlugType:I

    move/from16 v16, v0

    if-nez v16, :cond_2a0

    .line 338
    invoke-static {}, Landroid/os/SystemClock;->elapsedRealtime()J

    move-result-wide v16

    move-object/from16 v0, p0

    iget-wide v0, v0, Lcom/android/server/BatteryService;->mDischargeStartTime:J

    move-wide/from16 v18, v0

    sub-long v3, v16, v18

    .line 339
    const/4 v8, 0x1

    .line 342
    :cond_2a0
    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mPlugType:I

    move/from16 v16, v0

    if-eqz v16, :cond_3c0

    const/16 v16, 0x1

    move/from16 v11, v16

    .line 343
    .local v11, plugged:Z
    :goto_2ac
    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mLastPlugType:I

    move/from16 v16, v0

    if-eqz v16, :cond_3c6

    const/16 v16, 0x1

    move/from16 v10, v16

    .line 351
    .local v10, oldPlugged:Z
    :goto_2b8
    if-nez v11, :cond_3cc

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryStatus:I

    move/from16 v16, v0

    const/16 v17, 0x1

    move/from16 v0, v16

    move/from16 v1, v17

    if-eq v0, v1, :cond_3cc

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryLevel:I

    move/from16 v16, v0

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mLowBatteryWarningLevel:I

    move/from16 v17, v0

    move/from16 v0, v16

    move/from16 v1, v17

    if-gt v0, v1, :cond_3cc

    if-nez v10, :cond_2ee

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mLastBatteryLevel:I

    move/from16 v16, v0

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mLowBatteryWarningLevel:I

    move/from16 v17, v0

    move/from16 v0, v16

    move/from16 v1, v17

    if-le v0, v1, :cond_3cc

    :cond_2ee
    const/16 v16, 0x1

    move/from16 v12, v16

    .line 356
    .local v12, sendBatteryLow:Z
    :goto_2f2
    const/4 v13, 0x0

    .line 358
    .local v13, showLowLavel:Z
    move-object/from16 v0, p0

    iget-object v0, v0, Lcom/android/server/BatteryService;->mLowBatteryWarningLevelAry:[I

    move-object/from16 v16, v0

    if-eqz v16, :cond_3d8

    .line 359
    move-object/from16 v0, p0

    iget-object v0, v0, Lcom/android/server/BatteryService;->mLowBatteryWarningLevelAry:[I

    move-object/from16 v16, v0

    move-object/from16 v0, v16

    array-length v0, v0

    move v9, v0

    .line 360
    .local v9, loopSize:I
    const/4 v6, 0x0

    .local v6, i:I
    :goto_306
    if-ge v6, v9, :cond_3d8

    if-nez v13, :cond_3d8

    .line 361
    if-nez v11, :cond_3d2

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryStatus:I

    move/from16 v16, v0

    const/16 v17, 0x1

    move/from16 v0, v16

    move/from16 v1, v17

    if-eq v0, v1, :cond_3d2

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryLevel:I

    move/from16 v16, v0

    move-object/from16 v0, p0

    iget-object v0, v0, Lcom/android/server/BatteryService;->mLowBatteryWarningLevelAry:[I

    move-object/from16 v17, v0

    aget v17, v17, v6

    move/from16 v0, v16

    move/from16 v1, v17

    if-gt v0, v1, :cond_3d2

    if-nez v10, :cond_344

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mLastBatteryLevel:I

    move/from16 v16, v0

    move-object/from16 v0, p0

    iget-object v0, v0, Lcom/android/server/BatteryService;->mLowBatteryWarningLevelAry:[I

    move-object/from16 v17, v0

    aget v17, v17, v6

    move/from16 v0, v16

    move/from16 v1, v17

    if-le v0, v1, :cond_3d2

    :cond_344
    const/16 v16, 0x1

    move/from16 v13, v16

    .line 360
    :goto_348
    add-int/lit8 v6, v6, 0x1

    goto :goto_306

    .line 249
    .end local v6           #i:I
    .end local v9           #loopSize:I
    .end local v10           #oldPlugged:Z
    .end local v11           #plugged:Z
    .end local v12           #sendBatteryLow:Z
    .end local v13           #showLowLavel:Z
    :cond_34b
    const/16 v16, 0x0

    goto/16 :goto_1e

    .line 252
    :cond_34f
    move-object/from16 v0, p0

    iget-boolean v0, v0, Lcom/android/server/BatteryService;->mUsbOnline:Z

    move/from16 v16, v0

    if-eqz v16, :cond_364

    .line 253
    const/16 v16, 0x2

    move/from16 v0, v16

    move-object/from16 v1, p0

    iput v0, v1, Lcom/android/server/BatteryService;->mPlugType:I
    :try_end_35f
    .catchall {:try_start_27b .. :try_end_35f} :catchall_361

    goto/16 :goto_34

    .line 222
    .end local v3           #dischargeDuration:J
    .end local v8           #logOutlier:Z
    .end local v14           #showUnsupportedChargerWarningFlag:Z
    :catchall_361
    move-exception v16

    monitor-exit p0

    throw v16

    .line 255
    .restart local v3       #dischargeDuration:J
    .restart local v8       #logOutlier:Z
    .restart local v14       #showUnsupportedChargerWarningFlag:Z
    :cond_364
    const/16 v16, 0x0

    :try_start_366
    move/from16 v0, v16

    move-object/from16 v1, p0

    iput v0, v1, Lcom/android/server/BatteryService;->mPlugType:I

    goto/16 :goto_34

    .line 283
    :cond_36e
    const/4 v14, 0x1

    goto/16 :goto_14a

    .line 285
    :cond_371
    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mPlugType:I

    move/from16 v16, v0

    if-nez v16, :cond_14a

    .line 287
    invoke-static {}, Landroid/os/SystemClock;->elapsedRealtime()J

    move-result-wide v16

    move-wide/from16 v0, v16

    move-object/from16 v2, p0

    iput-wide v0, v2, Lcom/android/server/BatteryService;->mDischargeStartTime:J

    .line 288
    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryLevel:I

    move/from16 v16, v0

    move/from16 v0, v16

    move-object/from16 v1, p0

    iput v0, v1, Lcom/android/server/BatteryService;->mDischargeStartLevel:I

    .line 289
    const/16 v16, 0x0

    move/from16 v0, v16

    move-object/from16 v1, p0

    iput-boolean v0, v1, Lcom/android/server/BatteryService;->mUnsupportedCharger:Z

    goto/16 :goto_14a

    .line 293
    :cond_399
    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mPlugType:I

    move/from16 v16, v0

    if-eqz v16, :cond_3b2

    .line 305
    const/16 v16, 0x1

    move-object/from16 v0, p0

    iget-boolean v0, v0, Lcom/android/server/BatteryService;->mUnsupportedCharger:Z

    move/from16 v17, v0

    move/from16 v0, v16

    move/from16 v1, v17

    if-ne v0, v1, :cond_14a

    .line 306
    const/4 v14, 0x1

    goto/16 :goto_14a

    .line 308
    :cond_3b2
    const/16 v16, 0x0

    move/from16 v0, v16

    move-object/from16 v1, p0

    iput-boolean v0, v1, Lcom/android/server/BatteryService;->mUnsupportedCharger:Z

    goto/16 :goto_14a

    .line 314
    :cond_3bc
    const/16 v19, 0x0

    goto/16 :goto_1c4

    .line 342
    :cond_3c0
    const/16 v16, 0x0

    move/from16 v11, v16

    goto/16 :goto_2ac

    .line 343
    .restart local v11       #plugged:Z
    :cond_3c6
    const/16 v16, 0x0

    move/from16 v10, v16

    goto/16 :goto_2b8

    .line 351
    .restart local v10       #oldPlugged:Z
    :cond_3cc
    const/16 v16, 0x0

    move/from16 v12, v16

    goto/16 :goto_2f2

    .line 361
    .restart local v6       #i:I
    .restart local v9       #loopSize:I
    .restart local v12       #sendBatteryLow:Z
    .restart local v13       #showLowLavel:Z
    :cond_3d2
    const/16 v16, 0x0

    move/from16 v13, v16

    goto/16 :goto_348

    .line 368
    .end local v6           #i:I
    .end local v9           #loopSize:I
    :cond_3d8
    invoke-direct/range {p0 .. p0}, Lcom/android/server/BatteryService;->sendIntent()V

    .line 373
    new-instance v15, Landroid/content/Intent;

    invoke-direct {v15}, Landroid/content/Intent;-><init>()V

    .line 374
    .local v15, statusIntent:Landroid/content/Intent;
    const/high16 v16, 0x1000

    invoke-virtual/range {v15 .. v16}, Landroid/content/Intent;->setFlags(I)Landroid/content/Intent;

    .line 375
    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mPlugType:I

    move/from16 v16, v0

    if-eqz v16, :cond_56a

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mLastPlugType:I

    move/from16 v16, v0

    if-nez v16, :cond_56a

    .line 376
    const-string v16, "android.intent.action.ACTION_POWER_CONNECTED"

    invoke-virtual/range {v15 .. v16}, Landroid/content/Intent;->setAction(Ljava/lang/String;)Landroid/content/Intent;

    .line 379
    move-object/from16 v0, p0

    iget-object v0, v0, Lcom/android/server/BatteryService;->mContext:Landroid/content/Context;

    move-object/from16 v16, v0

    move-object/from16 v0, v16

    move-object v1, v15

    invoke-virtual {v0, v1}, Landroid/content/Context;->sendBroadcast(Landroid/content/Intent;)V

    .line 388
    :cond_406
    :goto_406
    if-eqz v12, :cond_410

    move-object/from16 v0, p0

    iget-object v0, v0, Lcom/android/server/BatteryService;->mLowBatteryWarningLevelAry:[I

    move-object/from16 v16, v0

    if-eqz v16, :cond_41a

    :cond_410
    move-object/from16 v0, p0

    iget-object v0, v0, Lcom/android/server/BatteryService;->mLowBatteryWarningLevelAry:[I

    move-object/from16 v16, v0

    if-eqz v16, :cond_58d

    if-eqz v13, :cond_58d

    .line 390
    :cond_41a
    const/16 v16, 0x1

    move/from16 v0, v16

    move-object/from16 v1, p0

    iput-boolean v0, v1, Lcom/android/server/BatteryService;->mSentLowBatteryBroadcast:Z

    .line 391
    const-string v16, "android.intent.action.BATTERY_LOW"

    invoke-virtual/range {v15 .. v16}, Landroid/content/Intent;->setAction(Ljava/lang/String;)Landroid/content/Intent;

    .line 393
    move-object/from16 v0, p0

    iget-object v0, v0, Lcom/android/server/BatteryService;->mContext:Landroid/content/Context;

    move-object/from16 v16, v0

    move-object/from16 v0, v16

    move-object v1, v15

    invoke-virtual {v0, v1}, Landroid/content/Context;->sendBroadcast(Landroid/content/Intent;)V

    .line 405
    :cond_433
    :goto_433
    const/16 v16, 0x1

    move/from16 v0, v16

    move v1, v14

    if-ne v0, v1, :cond_452

    .line 406
    const-string v16, "com.htc.content.intent.action.BATTERY_WARNING_INFO"

    invoke-virtual/range {v15 .. v16}, Landroid/content/Intent;->setAction(Ljava/lang/String;)Landroid/content/Intent;

    .line 407
    const-string v16, "com.htc.content.intent.extra.KEY_BATTERY_CHARGING_OVER_VOLTAGE"

    const/16 v17, 0x1

    invoke-virtual/range {v15 .. v17}, Landroid/content/Intent;->putExtra(Ljava/lang/String;Z)Landroid/content/Intent;

    .line 409
    move-object/from16 v0, p0

    iget-object v0, v0, Lcom/android/server/BatteryService;->mContext:Landroid/content/Context;

    move-object/from16 v16, v0

    move-object/from16 v0, v16

    move-object v1, v15

    invoke-virtual {v0, v1}, Landroid/content/Context;->sendBroadcast(Landroid/content/Intent;)V

    .line 414
    :cond_452
    if-eqz v8, :cond_460

    const-wide/16 v16, 0x0

    cmp-long v16, v3, v16

    if-eqz v16, :cond_460

    .line 415
    move-object/from16 v0, p0

    move-wide v1, v3

    invoke-direct {v0, v1, v2}, Lcom/android/server/BatteryService;->logOutlier(J)V

    .line 418
    :cond_460
    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryStatus:I

    move/from16 v16, v0

    move/from16 v0, v16

    move-object/from16 v1, p0

    iput v0, v1, Lcom/android/server/BatteryService;->mLastBatteryStatus:I

    .line 419
    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryHealth:I

    move/from16 v16, v0

    move/from16 v0, v16

    move-object/from16 v1, p0

    iput v0, v1, Lcom/android/server/BatteryService;->mLastBatteryHealth:I

    .line 420
    move-object/from16 v0, p0

    iget-boolean v0, v0, Lcom/android/server/BatteryService;->mBatteryPresent:Z

    move/from16 v16, v0

    move/from16 v0, v16

    move-object/from16 v1, p0

    iput-boolean v0, v1, Lcom/android/server/BatteryService;->mLastBatteryPresent:Z

    .line 421
    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryLevel:I

    move/from16 v16, v0

    move/from16 v0, v16

    move-object/from16 v1, p0

    iput v0, v1, Lcom/android/server/BatteryService;->mLastBatteryLevel:I

    .line 422
    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mPlugType:I

    move/from16 v16, v0

    move/from16 v0, v16

    move-object/from16 v1, p0

    iput v0, v1, Lcom/android/server/BatteryService;->mLastPlugType:I

    .line 423
    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryVoltage:I

    move/from16 v16, v0

    move/from16 v0, v16

    move-object/from16 v1, p0

    iput v0, v1, Lcom/android/server/BatteryService;->mLastBatteryVoltage:I

    .line 424
    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mBatteryTemperature:I

    move/from16 v16, v0

    move/from16 v0, v16

    move-object/from16 v1, p0

    iput v0, v1, Lcom/android/server/BatteryService;->mLastBatteryTemperature:I

    .line 425
    move-object/from16 v0, p0

    iget-boolean v0, v0, Lcom/android/server/BatteryService;->mBatteryLevelCritical:Z

    move/from16 v16, v0

    move/from16 v0, v16

    move-object/from16 v1, p0

    iput-boolean v0, v1, Lcom/android/server/BatteryService;->mLastBatteryLevelCritical:Z

    .line 426
    move-object/from16 v0, p0

    iget-boolean v0, v0, Lcom/android/server/BatteryService;->mUnsupportedCharger:Z

    move/from16 v16, v0

    move/from16 v0, v16

    move-object/from16 v1, p0

    iput-boolean v0, v1, Lcom/android/server/BatteryService;->mLastUnsupportedCharger:Z
    :try_end_4cc
    .catchall {:try_start_366 .. :try_end_4cc} :catchall_361

    .line 431
    .end local v10           #oldPlugged:Z
    .end local v11           #plugged:Z
    .end local v12           #sendBatteryLow:Z
    .end local v13           #showLowLavel:Z
    .end local v15           #statusIntent:Landroid/content/Intent;
    :cond_4cc
    :try_start_4cc
    invoke-static {}, Landroid/app/ActivityManagerNative;->isSystemReady()Z

    move-result v16

    if-nez v16, :cond_4da

    move-object/from16 v0, p0

    iget-boolean v0, v0, Lcom/android/server/BatteryService;->isBroadcsatBatteryIntent:Z

    move/from16 v16, v0

    if-eqz v16, :cond_568

    .line 433
    :cond_4da
    const/16 v16, 0x0

    move/from16 v0, v16

    move-object/from16 v1, p0

    iput-boolean v0, v1, Lcom/android/server/BatteryService;->isBroadcsatBatteryIntent:Z

    .line 434
    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mPlugType:I

    move/from16 v16, v0

    const/16 v17, 0x2

    move/from16 v0, v16

    move/from16 v1, v17

    if-ne v0, v1, :cond_4f6

    invoke-virtual/range {p0 .. p0}, Lcom/android/server/BatteryService;->isUsbConnected()Z

    move-result v16

    if-nez v16, :cond_504

    :cond_4f6
    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mPlugType:I

    move/from16 v16, v0

    if-nez v16, :cond_568

    invoke-virtual/range {p0 .. p0}, Lcom/android/server/BatteryService;->isUsbConnected()Z

    move-result v16

    if-nez v16, :cond_568

    .line 436
    :cond_504
    sget-object v16, Lcom/android/server/BatteryService;->TAG:Ljava/lang/String;

    new-instance v17, Ljava/lang/StringBuilder;

    invoke-direct/range {v17 .. v17}, Ljava/lang/StringBuilder;-><init>()V

    const-string v18, "isUsbConnected() = "

    invoke-virtual/range {v17 .. v18}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v17

    invoke-virtual/range {p0 .. p0}, Lcom/android/server/BatteryService;->isUsbConnected()Z

    move-result v18

    invoke-virtual/range {v17 .. v18}, Ljava/lang/StringBuilder;->append(Z)Ljava/lang/StringBuilder;

    move-result-object v17

    invoke-virtual/range {v17 .. v17}, Ljava/lang/StringBuilder;->toString()Ljava/lang/String;

    move-result-object v17

    invoke-static/range {v16 .. v17}, Landroid/util/Log;->d(Ljava/lang/String;Ljava/lang/String;)I

    .line 437
    sget-object v16, Lcom/android/server/BatteryService;->TAG:Ljava/lang/String;

    new-instance v17, Ljava/lang/StringBuilder;

    invoke-direct/range {v17 .. v17}, Ljava/lang/StringBuilder;-><init>()V

    const-string v18, "mPlugType = "

    invoke-virtual/range {v17 .. v18}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v17

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mPlugType:I

    move/from16 v18, v0

    invoke-virtual/range {v17 .. v18}, Ljava/lang/StringBuilder;->append(I)Ljava/lang/StringBuilder;

    move-result-object v17

    invoke-virtual/range {v17 .. v17}, Ljava/lang/StringBuilder;->toString()Ljava/lang/String;

    move-result-object v17

    invoke-static/range {v16 .. v17}, Landroid/util/Log;->d(Ljava/lang/String;Ljava/lang/String;)I

    .line 438
    new-instance v7, Landroid/content/Intent;

    const-string v16, "psclient.intent.action.usb_status"

    move-object v0, v7

    move-object/from16 v1, v16

    invoke-direct {v0, v1}, Landroid/content/Intent;-><init>(Ljava/lang/String;)V

    .line 439
    .local v7, intent:Landroid/content/Intent;
    const/high16 v16, 0x4000

    move-object v0, v7

    move/from16 v1, v16

    invoke-virtual {v0, v1}, Landroid/content/Intent;->addFlags(I)Landroid/content/Intent;

    .line 440
    const-string v16, "usb_status"

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mPlugType:I

    move/from16 v17, v0

    move-object v0, v7

    move-object/from16 v1, v16

    move/from16 v2, v17

    invoke-virtual {v0, v1, v2}, Landroid/content/Intent;->putExtra(Ljava/lang/String;I)Landroid/content/Intent;

    .line 441
    const/16 v16, 0x0

    move-object v0, v7

    move-object/from16 v1, v16

    invoke-static {v0, v1}, Landroid/app/ActivityManagerNative;->broadcastStickyIntent(Landroid/content/Intent;Ljava/lang/String;)V
    :try_end_568
    .catchall {:try_start_4cc .. :try_end_568} :catchall_361
    .catch Ljava/lang/Exception; {:try_start_4cc .. :try_end_568} :catch_5c2

    .line 448
    .end local v7           #intent:Landroid/content/Intent;
    :cond_568
    :goto_568
    monitor-exit p0

    return-void

    .line 381
    .restart local v10       #oldPlugged:Z
    .restart local v11       #plugged:Z
    .restart local v12       #sendBatteryLow:Z
    .restart local v13       #showLowLavel:Z
    .restart local v15       #statusIntent:Landroid/content/Intent;
    :cond_56a
    :try_start_56a
    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mPlugType:I

    move/from16 v16, v0

    if-nez v16, :cond_406

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mLastPlugType:I

    move/from16 v16, v0

    if-eqz v16, :cond_406

    .line 382
    const-string v16, "android.intent.action.ACTION_POWER_DISCONNECTED"

    invoke-virtual/range {v15 .. v16}, Landroid/content/Intent;->setAction(Ljava/lang/String;)Landroid/content/Intent;

    .line 385
    move-object/from16 v0, p0

    iget-object v0, v0, Lcom/android/server/BatteryService;->mContext:Landroid/content/Context;

    move-object/from16 v16, v0

    move-object/from16 v0, v16

    move-object v1, v15

    invoke-virtual {v0, v1}, Landroid/content/Context;->sendBroadcast(Landroid/content/Intent;)V

    goto/16 :goto_406

    .line 394
    :cond_58d
    move-object/from16 v0, p0

    iget-boolean v0, v0, Lcom/android/server/BatteryService;->mSentLowBatteryBroadcast:Z

    move/from16 v16, v0

    if-eqz v16, :cond_433

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mLastBatteryLevel:I

    move/from16 v16, v0

    move-object/from16 v0, p0

    iget v0, v0, Lcom/android/server/BatteryService;->mLowBatteryCloseWarningLevel:I

    move/from16 v17, v0

    move/from16 v0, v16

    move/from16 v1, v17

    if-lt v0, v1, :cond_433

    .line 395
    const/16 v16, 0x0

    move/from16 v0, v16

    move-object/from16 v1, p0

    iput-boolean v0, v1, Lcom/android/server/BatteryService;->mSentLowBatteryBroadcast:Z

    .line 396
    const-string v16, "android.intent.action.BATTERY_OKAY"

    invoke-virtual/range {v15 .. v16}, Landroid/content/Intent;->setAction(Ljava/lang/String;)Landroid/content/Intent;

    .line 398
    move-object/from16 v0, p0

    iget-object v0, v0, Lcom/android/server/BatteryService;->mContext:Landroid/content/Context;

    move-object/from16 v16, v0

    move-object/from16 v0, v16

    move-object v1, v15

    invoke-virtual {v0, v1}, Landroid/content/Context;->sendBroadcast(Landroid/content/Intent;)V

    goto/16 :goto_433

    .line 444
    .end local v10           #oldPlugged:Z
    .end local v11           #plugged:Z
    .end local v12           #sendBatteryLow:Z
    .end local v13           #showLowLavel:Z
    .end local v15           #statusIntent:Landroid/content/Intent;
    :catch_5c2
    move-exception v16

    move-object/from16 v5, v16

    .line 445
    .local v5, e:Ljava/lang/Exception;
    sget-object v16, Lcom/android/server/BatteryService;->TAG:Ljava/lang/String;

    new-instance v17, Ljava/lang/StringBuilder;

    invoke-direct/range {v17 .. v17}, Ljava/lang/StringBuilder;-><init>()V

    const-string v18, "Error: "

    invoke-virtual/range {v17 .. v18}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v17

    move-object/from16 v0, v17

    move-object v1, v5

    invoke-virtual {v0, v1}, Ljava/lang/StringBuilder;->append(Ljava/lang/Object;)Ljava/lang/StringBuilder;

    move-result-object v17

    invoke-virtual/range {v17 .. v17}, Ljava/lang/StringBuilder;->toString()Ljava/lang/String;

    move-result-object v17

    invoke-static/range {v16 .. v17}, Landroid/util/Log;->d(Ljava/lang/String;Ljava/lang/String;)I
    :try_end_5e0
    .catchall {:try_start_56a .. :try_end_5e0} :catchall_361

    goto :goto_568

    .line 330
    .end local v5           #e:Ljava/lang/Exception;
    :catch_5e1
    move-exception v16

    goto/16 :goto_27b
.end method


# virtual methods
.method protected dump(Ljava/io/FileDescriptor;Ljava/io/PrintWriter;[Ljava/lang/String;)V
    .registers 6
    .parameter "fd"
    .parameter "pw"
    .parameter "args"

    .prologue
    .line 618
    iget-object v0, p0, Lcom/android/server/BatteryService;->mContext:Landroid/content/Context;

    const-string v1, "android.permission.DUMP"

    invoke-virtual {v0, v1}, Landroid/content/Context;->checkCallingOrSelfPermission(Ljava/lang/String;)I

    move-result v0

    if-eqz v0, :cond_33

    .line 621
    new-instance v0, Ljava/lang/StringBuilder;

    invoke-direct {v0}, Ljava/lang/StringBuilder;-><init>()V

    const-string v1, "Permission Denial: can\'t dump Battery service from from pid="

    invoke-virtual {v0, v1}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v0

    invoke-static {}, Landroid/os/Binder;->getCallingPid()I

    move-result v1

    invoke-virtual {v0, v1}, Ljava/lang/StringBuilder;->append(I)Ljava/lang/StringBuilder;

    move-result-object v0

    const-string v1, ", uid="

    invoke-virtual {v0, v1}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v0

    invoke-static {}, Landroid/os/Binder;->getCallingUid()I

    move-result v1

    invoke-virtual {v0, v1}, Ljava/lang/StringBuilder;->append(I)Ljava/lang/StringBuilder;

    move-result-object v0

    invoke-virtual {v0}, Ljava/lang/StringBuilder;->toString()Ljava/lang/String;

    move-result-object v0

    invoke-virtual {p2, v0}, Ljava/io/PrintWriter;->println(Ljava/lang/String;)V

    .line 640
    :goto_32
    return-void

    .line 627
    :cond_33
    monitor-enter p0

    .line 628
    :try_start_34
    const-string v0, "Current Battery Service state:"

    invoke-virtual {p2, v0}, Ljava/io/PrintWriter;->println(Ljava/lang/String;)V

    .line 629
    new-instance v0, Ljava/lang/StringBuilder;

    invoke-direct {v0}, Ljava/lang/StringBuilder;-><init>()V

    const-string v1, "  AC powered: "

    invoke-virtual {v0, v1}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v0

    iget-boolean v1, p0, Lcom/android/server/BatteryService;->mAcOnline:Z

    invoke-virtual {v0, v1}, Ljava/lang/StringBuilder;->append(Z)Ljava/lang/StringBuilder;

    move-result-object v0

    invoke-virtual {v0}, Ljava/lang/StringBuilder;->toString()Ljava/lang/String;

    move-result-object v0

    invoke-virtual {p2, v0}, Ljava/io/PrintWriter;->println(Ljava/lang/String;)V

    .line 630
    new-instance v0, Ljava/lang/StringBuilder;

    invoke-direct {v0}, Ljava/lang/StringBuilder;-><init>()V

    const-string v1, "  USB powered: "

    invoke-virtual {v0, v1}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v0

    iget-boolean v1, p0, Lcom/android/server/BatteryService;->mUsbOnline:Z

    invoke-virtual {v0, v1}, Ljava/lang/StringBuilder;->append(Z)Ljava/lang/StringBuilder;

    move-result-object v0

    invoke-virtual {v0}, Ljava/lang/StringBuilder;->toString()Ljava/lang/String;

    move-result-object v0

    invoke-virtual {p2, v0}, Ljava/io/PrintWriter;->println(Ljava/lang/String;)V

    .line 631
    new-instance v0, Ljava/lang/StringBuilder;

    invoke-direct {v0}, Ljava/lang/StringBuilder;-><init>()V

    const-string v1, "  status: "

    invoke-virtual {v0, v1}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v0

    iget v1, p0, Lcom/android/server/BatteryService;->mBatteryStatus:I

    invoke-virtual {v0, v1}, Ljava/lang/StringBuilder;->append(I)Ljava/lang/StringBuilder;

    move-result-object v0

    invoke-virtual {v0}, Ljava/lang/StringBuilder;->toString()Ljava/lang/String;

    move-result-object v0

    invoke-virtual {p2, v0}, Ljava/io/PrintWriter;->println(Ljava/lang/String;)V

    .line 632
    new-instance v0, Ljava/lang/StringBuilder;

    invoke-direct {v0}, Ljava/lang/StringBuilder;-><init>()V

    const-string v1, "  health: "

    invoke-virtual {v0, v1}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v0

    iget v1, p0, Lcom/android/server/BatteryService;->mBatteryHealth:I

    invoke-virtual {v0, v1}, Ljava/lang/StringBuilder;->append(I)Ljava/lang/StringBuilder;

    move-result-object v0

    invoke-virtual {v0}, Ljava/lang/StringBuilder;->toString()Ljava/lang/String;

    move-result-object v0

    invoke-virtual {p2, v0}, Ljava/io/PrintWriter;->println(Ljava/lang/String;)V

    .line 633
    new-instance v0, Ljava/lang/StringBuilder;

    invoke-direct {v0}, Ljava/lang/StringBuilder;-><init>()V

    const-string v1, "  present: "

    invoke-virtual {v0, v1}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v0

    iget-boolean v1, p0, Lcom/android/server/BatteryService;->mBatteryPresent:Z

    invoke-virtual {v0, v1}, Ljava/lang/StringBuilder;->append(Z)Ljava/lang/StringBuilder;

    move-result-object v0

    invoke-virtual {v0}, Ljava/lang/StringBuilder;->toString()Ljava/lang/String;

    move-result-object v0

    invoke-virtual {p2, v0}, Ljava/io/PrintWriter;->println(Ljava/lang/String;)V

    .line 634
    new-instance v0, Ljava/lang/StringBuilder;

    invoke-direct {v0}, Ljava/lang/StringBuilder;-><init>()V

    const-string v1, "  level: "

    invoke-virtual {v0, v1}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v0

    iget v1, p0, Lcom/android/server/BatteryService;->mBatteryLevel:I

    invoke-virtual {v0, v1}, Ljava/lang/StringBuilder;->append(I)Ljava/lang/StringBuilder;

    move-result-object v0

    invoke-virtual {v0}, Ljava/lang/StringBuilder;->toString()Ljava/lang/String;

    move-result-object v0

    invoke-virtual {p2, v0}, Ljava/io/PrintWriter;->println(Ljava/lang/String;)V

    .line 635
    const-string v0, "  scale: 100"

    invoke-virtual {p2, v0}, Ljava/io/PrintWriter;->println(Ljava/lang/String;)V

    .line 636
    new-instance v0, Ljava/lang/StringBuilder;

    invoke-direct {v0}, Ljava/lang/StringBuilder;-><init>()V

    const-string v1, "  voltage:"

    invoke-virtual {v0, v1}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v0

    iget v1, p0, Lcom/android/server/BatteryService;->mBatteryVoltage:I

    invoke-virtual {v0, v1}, Ljava/lang/StringBuilder;->append(I)Ljava/lang/StringBuilder;

    move-result-object v0

    invoke-virtual {v0}, Ljava/lang/StringBuilder;->toString()Ljava/lang/String;

    move-result-object v0

    invoke-virtual {p2, v0}, Ljava/io/PrintWriter;->println(Ljava/lang/String;)V

    .line 637
    new-instance v0, Ljava/lang/StringBuilder;

    invoke-direct {v0}, Ljava/lang/StringBuilder;-><init>()V

    const-string v1, "  temperature: "

    invoke-virtual {v0, v1}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v0

    iget v1, p0, Lcom/android/server/BatteryService;->mBatteryTemperature:I

    invoke-virtual {v0, v1}, Ljava/lang/StringBuilder;->append(I)Ljava/lang/StringBuilder;

    move-result-object v0

    invoke-virtual {v0}, Ljava/lang/StringBuilder;->toString()Ljava/lang/String;

    move-result-object v0

    invoke-virtual {p2, v0}, Ljava/io/PrintWriter;->println(Ljava/lang/String;)V

    .line 638
    new-instance v0, Ljava/lang/StringBuilder;

    invoke-direct {v0}, Ljava/lang/StringBuilder;-><init>()V

    const-string v1, "  technology: "

    invoke-virtual {v0, v1}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v0

    iget-object v1, p0, Lcom/android/server/BatteryService;->mBatteryTechnology:Ljava/lang/String;

    invoke-virtual {v0, v1}, Ljava/lang/StringBuilder;->append(Ljava/lang/String;)Ljava/lang/StringBuilder;

    move-result-object v0

    invoke-virtual {v0}, Ljava/lang/StringBuilder;->toString()Ljava/lang/String;

    move-result-object v0

    invoke-virtual {p2, v0}, Ljava/io/PrintWriter;->println(Ljava/lang/String;)V

    .line 639
    monitor-exit p0

    goto/16 :goto_32

    :catchall_119
    move-exception v0

    monitor-exit p0
    :try_end_11b
    .catchall {:try_start_34 .. :try_end_11b} :catchall_119

    throw v0
.end method

.method final getBatteryLevel()I
    .registers 2

    .prologue
    .line 188
    iget v0, p0, Lcom/android/server/BatteryService;->mBatteryLevel:I

    return v0
.end method

.method final getPlugType()I
    .registers 2

    .prologue
    .line 176
    iget v0, p0, Lcom/android/server/BatteryService;->mPlugType:I

    return v0
.end method

.method final isPowered()Z
    .registers 3

    .prologue
    const/4 v1, 0x1

    .line 153
    iget-boolean v0, p0, Lcom/android/server/BatteryService;->mAcOnline:Z

    if-nez v0, :cond_d

    iget-boolean v0, p0, Lcom/android/server/BatteryService;->mUsbOnline:Z

    if-nez v0, :cond_d

    iget v0, p0, Lcom/android/server/BatteryService;->mBatteryStatus:I

    if-ne v0, v1, :cond_f

    :cond_d
    move v0, v1

    :goto_e
    return v0

    :cond_f
    const/4 v0, 0x0

    goto :goto_e
.end method

.method final isPowered(I)Z
    .registers 6
    .parameter "plugTypeSet"

    .prologue
    const/4 v3, 0x0

    const/4 v2, 0x1

    .line 159
    iget v1, p0, Lcom/android/server/BatteryService;->mBatteryStatus:I

    if-ne v1, v2, :cond_8

    move v1, v2

    .line 172
    :goto_7
    return v1

    .line 162
    :cond_8
    if-nez p1, :cond_c

    move v1, v3

    .line 163
    goto :goto_7

    .line 165
    :cond_c
    const/4 v0, 0x0

    .line 166
    .local v0, plugTypeBit:I
    iget-boolean v1, p0, Lcom/android/server/BatteryService;->mAcOnline:Z

    if-eqz v1, :cond_13

    .line 167
    or-int/lit8 v0, v0, 0x1

    .line 169
    :cond_13
    iget-boolean v1, p0, Lcom/android/server/BatteryService;->mUsbOnline:Z

    if-eqz v1, :cond_19

    .line 170
    or-int/lit8 v0, v0, 0x2

    .line 172
    :cond_19
    and-int v1, p1, v0

    if-eqz v1, :cond_1f

    move v1, v2

    goto :goto_7

    :cond_1f
    move v1, v3

    goto :goto_7
.end method

.method public isUsbConnected()Z
    .registers 3

    .prologue
    .line 451
    const-string v0, "usb_cable_connect"

    invoke-direct {p0, v0}, Lcom/android/server/BatteryService;->readFile(Ljava/lang/String;)Ljava/lang/String;

    move-result-object v0

    const-string v1, "1"

    invoke-virtual {v0, v1}, Ljava/lang/String;->equals(Ljava/lang/Object;)Z

    move-result v0

    return v0
.end method

.method systemReady()V
    .registers 1

    .prologue
    .line 193
    invoke-direct {p0}, Lcom/android/server/BatteryService;->shutdownIfNoPower()V

    .line 194
    invoke-direct {p0}, Lcom/android/server/BatteryService;->shutdownIfOverTemp()V

    .line 195
    return-void
.end method
